#ifndef OPEN_H
#define OPEN_H

/* open filename for reading and return the file handle or -1 on error */
extern int open_read(const char *filename);

/* create filename for exclusive write only use (mode 0600) and return
 * the file handle or -1 on error */
extern int open_excl(const char *filename);

/* open filename for appending  write only use (mode 0600)
 * and return the file handle or -1 on error.
 * All write operation will append after the last byte, regardless of
 * seeking or other processes also appending to the file.  The file will
 * be created if it does not exist. */
extern int open_append(const char *filename);

/* open filename for writing (mode 0644).  Create the file if it does
 * not exist, truncate it to zero length otherwise.  Return the file
 * handle or -1 on error. */
extern int open_trunc(const char *filename);

/* open filename for writing.  Create the file if it does not exist.
 * Return the file handle or -1 on error. */
extern int open_write(const char *filename);

#endif
